/*
 * Glacier - another Gnome email client.
 * Copyright (C) 1999 Lubomir Gelo
 *
 * Glacier uses code from other GPL-ed projects. See THANKS for 
 * credits and copyright info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "includes.h"

void    compose_cb (GtkWidget *widget, gchar *type);
void	send_cb (GtkWidget *widget, void *data);
void	cancel_send_cb (GtkWidget *widget, void *data);
void	IndentMsg (void);

/* 
 * Routine to compose mail.
 * Is called by the compose/reply/reply to all/forward buttons.
 * type can be: "new", "reply", "replytoall", "forward".
 */
void
compose_cb (GtkWidget *widget, gchar *type)
{
//	GtkWidget	*b_box;					/* hbox holding buttons. */
//	GtkWidget	*send_b, *cancel_b;		/* Send/Cancel buttons. */
//	GtkWidget	*label;
//	GtkWidget	*vscrollbar;
//	GtkWidget	*pixmap; 	/* Used in buttons. */
//	GdkFont		*font;
//	GtkStyle 	*style;



	/* If we are in reply/forward mode and we didn't even have a window
	open then we shouldn't even be here. */
//	if ((!(strcmp(type, "new")==0)) && (sendmsg->to_header == NULL)) return;

	/* Remove whatever is currently in the right pane. */
//	DestroyRightPane();

//	rightpane = gtk_table_new (9, 4, FALSE);
//	gtk_table_set_row_spacings (GTK_TABLE (rightpane), 2);
//	gtk_table_set_col_spacings (GTK_TABLE (rightpane), 2);

	/* Send/Cancel Buttons. */
//	b_box =  gtk_hbox_new (FALSE, 5);
//	gtk_table_attach (GTK_TABLE (rightpane), b_box, 0, 3, 0, 1,
//            GTK_FILL, GTK_FILL, 0, 10);
//	pixmap = gnome_stock_pixmap_widget(GTK_WIDGET (app), (const char *) GNOME_STOCK_BUTTON_OK);
//	send_b = gnome_pixmap_button(pixmap, "send message");
//	gtk_signal_connect (GTK_OBJECT (send_b), "clicked", GTK_SIGNAL_FUNC (send_cb), NULL);
//    gtk_box_pack_start(GTK_BOX (b_box), send_b, TRUE, TRUE, 20);
//	gtk_widget_show(send_b);

//	pixmap = gnome_stock_pixmap_widget(GTK_WIDGET (app), (const char *) GNOME_STOCK_BUTTON_CANCEL);
//	cancel_b = gnome_pixmap_button(pixmap, "cancel");

//	gtk_signal_connect (GTK_OBJECT (cancel_b), "clicked", GTK_SIGNAL_FUNC (cancel_send_cb), NULL);
//    gtk_box_pack_start(GTK_BOX (b_box), cancel_b, TRUE, TRUE, 20);
//	gtk_widget_show(cancel_b);
//	gtk_widget_show(b_box);

	/* To: */
//	label = gtk_label_new ("to:");
//	gtk_misc_set_alignment (GTK_MISC (label), 0.9, 0.5);
//	gtk_table_attach (GTK_TABLE (rightpane), label, 0, 1, 1, 2,
//            GTK_FILL, GTK_FILL, 0, 0);
//	gtk_widget_show(label);

//	sendmsg->to = gtk_entry_new ();
//	gtk_table_attach (GTK_TABLE (rightpane), sendmsg->to, 1, 2, 1, 2,
//            GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	/* From: */
//	label = gtk_label_new ("from:");
//	gtk_misc_set_alignment (GTK_MISC (label), 0.9, 0.5);
//	gtk_table_attach (GTK_TABLE (rightpane), label, 0, 1, 2, 3,
//            GTK_FILL, GTK_FILL, 0, 0);
//	gtk_widget_show(label);

//	sendmsg->from = gtk_entry_new ();
//	gtk_table_attach (GTK_TABLE (rightpane), sendmsg->from, 1, 2, 2, 3,
//            GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	/* Subject: */
//	label = gtk_label_new ("subject:");
//	gtk_misc_set_alignment (GTK_MISC (label), 0.9, 0.5);
//	gtk_table_attach (GTK_TABLE (rightpane), label, 0, 1, 3, 4,
//            GTK_FILL, GTK_FILL, 0, 0);
//	gtk_widget_show(label);

//	sendmsg->subject = gtk_entry_new ();
//	gtk_table_attach (GTK_TABLE (rightpane), sendmsg->subject, 1, 2, 3, 4,
//            GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	/* cc: */
//	label = gtk_label_new ("cc:");
//	gtk_misc_set_alignment (GTK_MISC (label), 0.9, 0.5);
//	gtk_table_attach (GTK_TABLE (rightpane), label, 0, 1, 4, 5,
//            GTK_FILL, GTK_FILL, 0, 0);
//	gtk_widget_show(label);

//	sendmsg->cc = gtk_entry_new ();
//	gtk_table_attach (GTK_TABLE (rightpane), sendmsg->cc, 1, 2, 4, 5,
//            GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	/* bcc: */
//	label = gtk_label_new ("bcc:");
//	gtk_misc_set_alignment (GTK_MISC (label), 0.9, 0.5);
//	gtk_table_attach (GTK_TABLE (rightpane), label, 0, 1, 5, 6,
//            GTK_FILL, GTK_FILL, 0, 0);
//	gtk_widget_show(label);

//	sendmsg->bcc = gtk_entry_new ();
//	gtk_table_attach (GTK_TABLE (rightpane), sendmsg->bcc, 1, 2, 5, 6,
//            GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	/* attach: */
//	label = gtk_label_new ("attach:");
//	gtk_misc_set_alignment (GTK_MISC (label), 0.9, 0.5);
//	gtk_table_attach (GTK_TABLE (rightpane), label, 0, 1, 6, 7,
//            GTK_FILL, GTK_FILL, 0, 0);
//	gtk_widget_show(label);

//	sendmsg->attach = gtk_entry_new ();
//	gtk_table_attach (GTK_TABLE (rightpane), sendmsg->attach, 1, 2, 6, 7,
//            GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	/* message: */
//	label = gtk_label_new ("message:");
//	gtk_misc_set_alignment (GTK_MISC (label), 0.9, 0.95);
//	gtk_table_attach (GTK_TABLE (rightpane), label, 0, 1, 7, 8,
//            GTK_FILL, GTK_SHRINK, 0, 0);
//	gtk_widget_show(label);

//	style = gtk_style_new ();
//	font = gdk_font_load ("-adobe-courier-medium-r-*-*-*-120-*-*-*-*-iso8859-1");
//	style->font = font;
//	sendmsg->text = gtk_text_new (NULL, NULL);
//	gtk_text_set_editable (GTK_TEXT (sendmsg->text), TRUE);
//	gtk_text_set_word_wrap (GTK_TEXT (sendmsg->text), TRUE);
//	gtk_widget_set_style (sendmsg->text, style);

//    vscrollbar = gtk_vscrollbar_new (GTK_TEXT(sendmsg->text)->vadj);

//    gtk_table_attach (GTK_TABLE (rightpane), sendmsg->text, 1, 2, 7, 8,
//            GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND, 0, 10);
//    gtk_table_attach (GTK_TABLE (rightpane), vscrollbar, 2, 3, 7, 8,
//            GTK_FILL , GTK_FILL | GTK_EXPAND, 0, 10);

//	gtk_window_set_title(GTK_WINDOW (app), "Glacier: Compose Message");

	/* Put in values to the fields if we need too. */	
//	if (!strcmp(type, "new")==0) {
//		if (sendmsg->to_header && !strcmp(type, "forward")==0) gtk_entry_set_text(GTK_ENTRY (sendmsg->to), sendmsg->to_header);	
//		if (sendmsg->sub_header) {
///			gtk_entry_set_text(GTK_ENTRY (sendmsg->subject), "Re:");	
//			gtk_entry_append_text(GTK_ENTRY (sendmsg->subject), sendmsg->sub_header);	
//			}
//
//		if (!sendmsg->indent) IndentMsg();	 /*Indent the old message */
//		gtk_text_insert (GTK_TEXT (sendmsg->text), NULL, &sendmsg->text->style->black, &sendmsg->text->style->white, sendmsg->message->str, -1);
//		}	

//	gtk_entry_set_text(GTK_ENTRY (sendmsg->from), "insert your email addy here");	

//	gtk_widget_show(sendmsg->to);
//	gtk_widget_show(sendmsg->from);
//	gtk_widget_show(sendmsg->subject);
//	gtk_widget_show(sendmsg->cc);
//	gtk_widget_show(sendmsg->bcc);
//	gtk_widget_show(sendmsg->attach);
//    gtk_widget_show (vscrollbar);
//	gtk_widget_show(sendmsg->text);
//    gtk_paned_add2 (GTK_PANED(hpaned), rightpane);
//	gtk_widget_show(rightpane);

//	return;
}

/* 
 * Callback for when they click on the 'send' button in the compose window. 
 * Will parse the compose window, and send the message.
 *
 */
void
send_cb (GtkWidget *widget, void *data)
{
//	gchar 	*message;
//	gchar	*to, *from, *subject, *cc, *bcc, *attach;
//	FILE	*outmail;
//	gchar 	*sendmail; /* String containing the sendmail command line. */
//	GtkWidget *dialog; 

//	/* Grab data from the entry fields into variables. */
//	/* FIXME: need to remove any newlines on the end... */
//	message = gtk_editable_get_chars(GTK_EDITABLE (sendmsg->text), 0, -1);
//	to = gtk_entry_get_text(GTK_ENTRY(sendmsg->to));
//	from = gtk_entry_get_text(GTK_ENTRY(sendmsg->from));
//	subject = gtk_entry_get_text(GTK_ENTRY(sendmsg->subject));
//	cc = gtk_entry_get_text(GTK_ENTRY(sendmsg->cc));
//	bcc = gtk_entry_get_text(GTK_ENTRY(sendmsg->bcc));
//	attach = gtk_entry_get_text(GTK_ENTRY(sendmsg->attach));


//	/* Lets do some primitive error checking. */

//	/* Missing "To:" field. */
//	if (strlen(to) < 2) {  
//		dialog = gnome_message_box_new("please fill out the \"To:\" field", GNOME_MESSAGE_BOX_ERROR, "ok", 0);
//    	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);
//    	gtk_widget_show(dialog);
//		return;
//		}

//	/* Missing "Subject:" field. */
//	if (strlen(subject) < 2) {
//		dialog = gnome_message_box_new("subject field missing\n(don't you realise how incredibly annoying emails without subjects are?)", GNOME_MESSAGE_BOX_WARNING, "ok", 0);
//    	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);
//    	gtk_widget_show(dialog);
//	    return;
//		}

//	g_print("To: %s\nFrom: %s\nSubject: %s\nCc: %s\nBcc: %s\nAttach: %s\n%s\n", to, from, subject, cc, bcc, attach, message);
//
//	/* Create temporary file to hold email message. */
//	outmail = fopen(".glacier_tmp", "w");
//	fprintf(outmail, "To: %s\nFrom: %s\nSubject: %s\nCc: %s\nBcc: %s\nAttach: %s\n%s\n", to, from, subject, cc, bcc, attach, message); 
//	fclose(outmail);
//
//	/* Output to a file and sendmail it */
//	sendmail = g_strdup_printf("sendmail \"%s\" < .glacier_tmp", to);

	/* 
	 * Using system() is a bad way to do this... We need it to be
 	 * threaded somehow, and we need to manage the results...
     * this is really just a hack until we get direct smtp support in.
     */
//	system(sendmail); 
	
	/* Send positive feedback to the user. */
//	dialog = gnome_message_box_new("message sent (probably)", GNOME_MESSAGE_BOX_INFO, "ok", 0);
//    gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);
//    gtk_widget_show(dialog);

	/* We can close the compose window now. */
//	cancel_send_cb(widget, data);

	/* Probably should also add the message to the "outgoing" mailbox
	at this point. Wait until we get prefs setup properly. */
}


/* Callback for when they click on the 'cancel' button in a compose window.
Currently it just removes the right pane.
Ideally, it would take them back to the original message they were replying too, if that was the context. */
void
cancel_send_cb (GtkWidget *widget, void *data)
{
//	/* Remove whatever is currently in the right pane. */
//	if (GTK_IS_WIDGET(rightpane)) gtk_container_remove(GTK_CONTAINER (hpaned), rightpane);
//
//	/* Clear the sendmsg buffer... */
//	g_free(sendmsg->to_header);
//	sendmsg->to_header = NULL;
//	g_free(sendmsg->sub_header);
//	sendmsg->sub_header = NULL;
//	g_string_free(sendmsg->message, TRUE);
//    sendmsg->message = g_string_new(NULL);
}

/* This routine is called to put indents at the start of each line of the
 * message in the static cache. 
 * FIXME: Do we add other stuff? like "thingy wrote:\n" first?
 */
void
IndentMsg (void) {

//	gchar *tok;  /* tokenizer we use to find newlines. */
//	gint diff=0; /* the number of chars until just after a newline. */

//	while (diff < sendmsg->message->len) {

//		/* Insert the indent after the newline. */
//		/* FIXME: Use a configurable indent from prefs. */
//		g_string_insert(sendmsg->message, diff, "> ");

//		/* Move the token just past the newline. */
//		tok = sendmsg->message->str + diff;

//		/* Work out the distance to the next newline + 1 */
//		diff += strcspn(tok, "\n")+1; 
//	}
//	g_string_insert(sendmsg->message, 0, "\n");
//	sendmsg->indent = TRUE;
}
