#include "includes.h"

#include "pixmaps/inbox.xpm"
#include "pixmaps/outbox.xpm"
#include "pixmaps/trash.xpm"

#include "pixmaps/dir_closed.xpm"
#include "pixmaps/dir_open.xpm"

#include "pixmaps/tray_empty.xpm"
#include "pixmaps/tray_full.xpm"

#include "pixmaps/replied.xpm"
#include "pixmaps/forwarded.xpm"

#include "pixmaps/envelope.xpm"
#include "pixmaps/attachment.xpm"


typedef struct _Icon Icon;

struct _Icon  {
    GdkPixmap *p;
    GdkBitmap *b;

};

static Icon inbox;
static Icon outbox;
static Icon trash;

static Icon tray_empty;
static Icon tray_full;

static Icon dir_open;
static Icon dir_closed;

static Icon replied;
static Icon forwarded;

static Icon envelope;
static Icon attachment;

static void create_icon (gchar ** data, GdkPixmap ** pmap, GdkBitmap ** bmap){

  *pmap = gdk_pixmap_create_from_xpm_d (GDK_ROOT_PARENT (), bmap, 0, data);
}

void icons_init (void) {

    create_icon (inbox_xpm, &inbox.p, &inbox.b);
    create_icon (outbox_xpm, &outbox.p, &outbox.b);
    create_icon (trash_xpm, &trash.p, &trash.b);

    create_icon (tray_empty_xpm, &tray_empty.p, &tray_empty.b);
    create_icon (tray_full_xpm, &tray_full.p, &tray_full.b);

    create_icon (dir_closed_xpm, &dir_closed.p, &dir_closed.b);
    create_icon (dir_open_xpm, &dir_open.p, &dir_open.b);

    create_icon (replied_xpm, &replied.p, &replied.b);
    create_icon (forwarded_xpm, &forwarded.p, &forwarded.b);

    create_icon (envelope_xpm, &envelope.p, &envelope.b);

    create_icon (attachment_xpm, &attachment.p, &attachment.b);

}

GdkPixmap *icon_get_pixmap (IconName name){

    switch (name){

	case ICON_INBOX:
            return inbox.p;

	case ICON_OUTBOX:
            return outbox.p;

	case ICON_TRASH:
            return trash.p;

	case ICON_TRAY_EMPTY:
            return tray_empty.p;
	    
	case ICON_TRAY_FULL:
            return tray_full.p;

	case ICON_DIR_CLOSED:
            return dir_closed.p;
    
	case ICON_DIR_OPEN:
            return dir_open.p;

	case ICON_REPLIED:
            return replied.p;
    
	case ICON_FORWARDED:
            return forwarded.p;

	case ICON_ENVELOPE:
            return envelope.p;

	case ICON_ATTACHMENT:
            return attachment.p;

    }

    return NULL;
}

GdkBitmap *icon_get_bitmap (IconName name){

    switch (name){

	case ICON_INBOX:
            return inbox.b;

	case ICON_OUTBOX:
            return outbox.b;

	case ICON_TRASH:
            return trash.b;

	case ICON_TRAY_EMPTY:
            return tray_empty.b;
	    
	case ICON_TRAY_FULL:
            return tray_full.b;

	case ICON_DIR_CLOSED:
            return dir_closed.b;
    
	case ICON_DIR_OPEN:
            return dir_open.b;

	case ICON_REPLIED:
            return replied.b;
    
	case ICON_FORWARDED:
            return forwarded.b;

	case ICON_ENVELOPE:
            return envelope.b;

	case ICON_ATTACHMENT:
            return attachment.b;

    }

    return NULL;
}
