/*
 * Glacier - another Gnome email client.
 * Copyright (C) 1999 Lubomir Gelo
 *
 * Glacier uses code from other GPL-ed projects. See THANKS for 
 * credits and copyright info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef __MAIN_H__ 
#define __MAIN_H__

#define DEBUG

#define SKIPWS(x) 	while(isspace(*x))x++
#define ISSPACE 	isspace
#define strfcpy(a,b,c) 	{ if (c) {strncpy(a,b,c);a[c-1]=0;} }

#define HUGE_STRING	5120
#define LONG_STRING     1024
#define STRING          256
#define SHORT_STRING    128

#define MAXLOCKATTEMPT	3

#ifdef DEBUG
#define dprint(N,X) if(debuglevel>=N) fprintf X
#else
#define dprint(N,X) 
#endif

#ifdef DEBUG
extern	gint debuglevel;
#endif

enum {

    APP_LAYOUT_I,			/* no message preview */
    APP_LAYOUT_C,			
    APP_LAYOUT_U
};

/* Structures */

typedef struct _GlacierApp GlacierApp;

struct _GlacierApp {

    /* identity */
    gchar		*real_name;
    gchar		*email_address;
    gchar		*reply_to_address;
    gchar		*signature;
    
    /* run-time */
    GlacierMbTree	*mailbox_tree;
    Mailbox		*current_mailbox;
    gboolean		signals_blocked;

    /* widgets */
    GtkWindow		*app;
    
    GtkWidget		*hpaned;
    GtkWidget		*vpaned;

    GtkWidget		*message_list;
    GlacierMsgview	*message_preview;
    GList		*mailbox_list;

    GnomeAppBar 	*status_bar;

    /* main window visual aspects */
    gint		app_width;
    gint		app_height;
    gint		mbtree_width;
    gint		mbtree_height;
    gint		msglist_width;
    gint		msglist_height;
    gint		msgview_width;
    gint		msgview_height;

    gint		layout;
    gint		toolbar_style;

    /* config file version */
    gchar		*config_version;

    /* mailboxes */
    gchar		*inbox;
    gchar		*trash;
    gchar		*outbox;
    gchar		*drafts;
    gchar		*mail_dir;

    /* locale */
    gchar		*charset;
    
};


void set_cursor (gint type);

#endif /* __MAIN_H__ */
