/*
 * Glacier - another Gnome email client.
 * Copyright (C) 1999 Lubomir Gelo
 *
 * Glacier uses code from other GPL-ed projects. See THANKS for 
 * credits and copyright info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef __MBTREE_H__
#define __MBTREE_H__

#define GLACIER_MBTREE(obj)          GTK_CHECK_CAST (obj, glacier_mbtree_get_type (), GlacierMbTree)
#define GLACIER_MBTREE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, glacier_mbtree_get_type (), GlacierMbTreeClass)
#define GLACIER_IS_MBTREE(obj)       GTK_CHECK_TYPE (obj, glacier_mbtree_get_type ())

typedef struct _GlacierMbTree GlacierMbTree;
typedef struct _GlacierMbTreeClass GlacierMbTreeClass;

struct _GlacierMbTree {

    GtkCTree ctree;
};

struct _GlacierMbTreeClass {

    GtkCTreeClass parent_class;

    void (*glacier_mbtree_select) (GlacierMbTree * bmblist, Mailbox * mailbox, gint row,  GdkEventButton *);
};

void glacier_mbtree_load_mailboxes(void);
GlacierMbTree *glacier_mbtree_new(GtkWidget *paned, int position);
void glacier_mbtree_close_mailboxes(GList *list);

void glacier_utils_remove_files (gchar *path);


gboolean glacier_utils_create_file(gchar *filename, int mode);
gboolean glacier_utils_create_dir (gchar *path, int mode);

#endif /* __MBTREE_H__ */
