/*
 * Glacier - another Gnome email client.
 * Copyright (C) 1999 Lubomir Gelo
 *
 * Glacier uses code from other GPL-ed projects. See THANKS for 
 * credits and copyright info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef __MESSAGE_H__
#define __MESSAGE_H__

#define MSG_CONTENT(m) 		((Body *)(m->content))
#define MSG_ENVELOPE(m,f)	(((Envelope *)(((Message *)(m))->envelope))->f)

Message *message_new(Mailbox *mailbox);
void message_free(Message *message);

void message_read_header (FILE *file, Message *msg);
void message_parse_mime_message (Message *msg);
void message_decode_attachment (Body *b, State *s);
int message_check_read_status(FILE *file);


Envelope *envelope_new(void);
void envelope_free(Envelope *envelope);

void header_free(Header *header);
Header *header_new(void);

void body_free(Body *body);
Body *body_new(void);

void parameter_free(Parameter *param);
Parameter *parameter_new(void);

#endif /* __MESSAGE_H__ */
