#ifndef __MSGVIEW_H__
#define __MSGVIEW_H__

#define GLACIER_MSGVIEW(obj)          GTK_CHECK_CAST (obj, msgview_get_type (), GlacierMsgview)
#define GLACIER_MSGVIEW_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, msgview_get_type (), GlacierMsgviewClass)
#define GLACIER_IS_MSGVIEW(obj)       GTK_CHECK_TYPE (obj, msgview_get_type ())


typedef struct _GlacierMsgview GlacierMsgview;
typedef struct _GlacierMsgviewClass GlacierMsgviewClass;

enum {

    MSGVIEW_RAW_MESSAGE,
    MSGVIEW_NORMAL_HEADERS,
    MSGVIEW_DETAILED_HEADERS,
    MSGVIEW_ALL_HEADERS
};

struct _GlacierMsgview {

    GnomeCanvas canvas;
    GnomeCanvasGroup *headers;
    GnomeCanvasGroup *body;

    Message *message;
};

struct _GlacierMsgviewClass {

    GnomeCanvasClass parent_class;

};

guint msgview_get_type(void);
GlacierMsgview *msgview_new(void);
void msgview_clear(GlacierMsgview *msgview);
void msgview_set(GlacierMsgview *msgview, Message *message, int mode);

#endif /* __MSGVIEW_H__ */
