/*
 * Glacier - another Gnome email client.
 * Copyright (C) 1999 Lubomir Gelo
 *
 * Glacier uses code from other GPL-ed projects. See THANKS for 
 * credits and copyright info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef __SETTINGS_H__
#define __SETTINGS_H__

void prefs_load(void);
void prefs_set_defaults(void);
void prefs_save(void);
void prefs_free(void);
int prefs_check_config_version(void);
void prefs_dialog_open(void);

#define NUM_TOOLBAR_MODES 3
#define NUM_LAYOUT_MODES 3

typedef struct _GlacierPrefs {

    GnomePropertyBox 	*dialog;

    GtkRadioButton 	*toolbar_type[NUM_TOOLBAR_MODES];
    GtkRadioButton 	*main_window_layout[NUM_LAYOUT_MODES];

    GtkWidget 		*real_name, *email, *replyto, *signature;
    GtkWidget		*inbox, *outbox, *drafts, *trash, *mail_dir;

} GlacierPrefs;

enum {

    GLACIER_NOT_CONFIGURED,
    GLACIER_CONFIG_VERSION_OK,
    GLACIER_CONFIG_IS_OLD,
    GLACIER_CONFIG_IS_NEWER
};


#endif /* __SETTINGS_H__ */
