/*
 * Glacier - another Gnome email client.
 * Copyright (C) 1999 Lubomir Gelo
 *
 * Glacier uses code from other GPL-ed projects. See THANKS for 
 * credits and copyright info.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef __UTILS_H__
#define __UTILS_H__

#define G_FREE(p)	if (p != NULL) { g_free(p); p=NULL; }



#define SECONDS_PER_DAY 	86400L
#define SECONDS_PER_WEEK 	604800

int utils_lock_file (const char *path, int fd, int excl, int dot, int timeout);
int utils_unlock_file (const char *path, int fd);

void utils_block_signals (void);
void utils_unblock_signals (void);

const char *utils_get_next_word (const char *s);
void utils_dequote_comment (char *s);
char *utils_substrdup (const char *begin, const char *end);

void utils_print_friendly_time(time_t ptime, gchar **string_date, gchar **string_time);
void utils_normalize_time (struct tm *tm);
gchar *utils_print_time(time_t ptime);
time_t utils_local_tz (void);
time_t utils_mktime (struct tm *t, int local);
time_t utils_compute_tz (time_t g, struct tm *utc);
int utils_check_month (const char *s);
int utils_is_day_name (const char *s);
const char *utils_uncomment_timezone (char *buf, size_t buflen, const char *tz);

FILE *utils_mktemp (char **filename);
size_t utils_readfile (FILE * fp, char **buf);

void utils_decode_base64 (State *s, long len, int istext);
void utils_decode_xbit (State *s, long len, int istext);
void utils_decode_quoted (State *s, long len, int istext);


int utils_copy_bytes (FILE *in, FILE *out, size_t size);
void utils_gui_update_hook (int count, int total);

#endif /* __UTILS_H__ */
